//==========================================================================
//	Author				: Erfan Khalilian TP015171		
//	Project				: Automatic Control System for AQUARIUM
//	Project description	: This project will use PIC16F877A to control temperature , light and feeder of aquarium,
//                        while the certain temperature detected then cooling fan and alarm will be activated 
//						  during the darkness the lamp will be activated (using LDR), 
//                        at certain time motor will rotate CW and CCW to realse preselected amount of feed in aquarium (close and open the door with help of motor)
//==========================================================================
#include "config.h"
#include <htc.h>
#include <math.h>

//==================include=================================
/*#include<pic.h>

#ifndef _XTAL_FREQ
 // Unless already defined assume 4MHz system frequency
 // This definition is required to calibrate __delay_us() and __delay_ms()
 #define _XTAL_FREQ 20000000
#endif

#include <htc.h>*/

//===============configuration==============================
__CONFIG (0x3F32);

//===============define IO port=============================
//#define _XTAL_FREQ 20000000
#define		lcd			PORTD // maybe it should be lcd_data
#define		RS			RB4
#define		E			RB5
#define		CHANNEL0	0b10000001	// AN0
#define		CHANNEL1	0b10001001	// AN1
#define		lamp		        RC0 // light 
#define		alarm 		        RC1 // activate as fan but I put led for this part 
#define     motor               RC2//DC motor activate as fan 
#define     servo               RC4// servo motor
#define     run                 RC6// CW dc motor
#define     direct              RC7// CCW dc motor



//==============FUNCTION PTOTOTYPE=========================
void e_pulse(void);
void delayy(unsigned short i);
void pause (unsigned short e);
void send_char(unsigned char data);
void send_config(unsigned char data);
void lcd_goto(unsigned char data);
void lcd_clr(void);
void send_string(const char *s);
void dis_num(unsigned long data);   //  this function I can't understand I think for send the value of sensor to display in LCD
void increment(unsigned long data); // this Function I don't understand 
void read_adc(void);                // this function is for reading value of sensor ***adc reading***
unsigned short read_temp(void);     // this function I don't understand the operation
void feeder (void);
void servomotor (void);
//====================MAIN================================

unsigned short result;
unsigned short temp,light; //introduce 3 variable for sensors 
unsigned short e;
unsigned int   t=0;
float		   temperature; // made temperature a float

//unsigned char speed=50;
void main(void)
{
	ADRESH=0;					//clear A/D result
	ADRESL=0;					//clear A/D result

	//setting ADCON1 Register
	ADCON1=0b11000000;			// A/D result right justified, I modified to ALL AN channels as analoug input 				
								// configure RA2 and RA5 as digital I/O// have changed

	TRISA=0b11111111;			//configure PORTA as input 
	TRISB=0b00000000;			//configure PORTB as output
	TRISC=0b00000000;			//configure PORTC as output
    TRISD=0b00000000;           //configure PORTD as output
	PORTA=0;
	PORTB=0;
    PORTC=0;
//////////////////////SET PWM//////////////////////////////////////

CCP1CON = 0b00001100;			//PWM Mode
PR2 = 0xFF;						//PWM Period Setting//PWM frequecy set as 4.88KHz
T2CON = 0b00000101;		//Timer2 On, prescale 4
CCPR1L=0;

/////////////////////LCD CONFIGURATION/////////////////////////////

    send_config(0b00000001);		//clear display at lcd
	send_config(0b00000010);		//Lcd Return to home 
	send_config(0b00000110);		//entry mode-cursor increase 1
	send_config(0b00001100);		//diplay on, cursor off and cursor blink off
	send_config(0b00111000);		//function set

/////////////////////////////INITILIZE LCD/////////////////////////	
	while(1)					
	{
		
		
		lcd_goto(0);					//cursor start from beginning
		
		//display character on LCD
		send_char('L');
		send_char('I');
		send_char('G');
		send_char('H');
		send_char('T');
		send_char('=');	

		lcd_goto(20);					//cursor go to 2nd line of the LCD

		//display character on LCD
	
		send_char('T');
		send_char('E');
		send_char('M');
		send_char('P');
		send_char('=');

////////////////////////////////SET UP FOR ADC FOR LIGHT SENSOR/////////////////////////////	

		while(1)						//infinity loop
		{
		//sensor A
		ADCON0=CHANNEL0;				//CHANNEL1=0b10001001
		lcd_goto(8);
		read_adc();
    	temp=read_temp();// reading value from sensor
      	dis_num(temp/10);//show the value 
		send_char('.');  //this line is to show . to seprate desimal value from double value
		dis_num(temp%10);//show the double value 
		light=temp;
		


////////////////////////////////SET UP FOR ADC FOR TEMPERATURE SENSOR/////////////////////////////	


		//sensor B
		ADCON0=CHANNEL1;				//CHANNEL0=0b10000001			
        lcd_goto(28);
		read_adc();
        temp=read_temp();
        temperature = (((float)temp)*0.48876);
        dis_num((unsigned long)round(temperature));
	//	dis_num(temp *0.48876);
	//	send_char('.');
	//	dis_num((temp%10)*(0.48876));
		send_char(0b11011111);//I have found that this syntax is for make degree celecius 
    	send_char('C');
		send_char(' ');
		send_char(' ');

	//	temperature=temp;


//////////////////////////////////////////////////CONDITIONS FOR ACTUATORS/////////////////////////////////////////////////////////



			if(temperature>27)// when the temperature goes above the 27 degree C the fan activated otherwise the fan is deactivated		
				{							
					alarm=1;			
				}	
  
          else {
				 alarm=0;
				}
   

		if(light<150)// if there is darkness the lamp or LED (as indicator)will be activated otherwise while there is light the lamp is off		
				{							
				   lamp=1;			
				}	

			else  
				{							
					lamp=0;			   		
			    }


	delayy(2000);

servomotor();
feeder();




}

	}


    
	}
		
		
					

//==================subroutine LCD setting ==========================

void send_config(unsigned char data)
{
 	RS=0;
	lcd=data;
	delayy(500);
	e_pulse();
}

void e_pulse(void)
{
	E=1;
	delayy(500);
	E=0;
	delayy(500);
}

void send_char(unsigned char data)
{
 	RS=1;
	lcd=data;
	delayy(500);
	e_pulse();
}


void lcd_goto(unsigned char data)
{
 	if(data<16)
	{
	 	send_config(0x80+data);
	}
	else
	{
	 	data=data-20;
		send_config(0xc0+data);
	}
}


void lcd_clr(void)
{
	RS=0;
 	send_config(0x01);
	delayy(600);	
}


void send_string(const char *s)			//send a string to display in the lcd
{          
	unsigned char i=0;
  	while (s && *s)send_char (*s++);

}



void dis_num(unsigned long data)
{
	unsigned char hundred_thousand;
	unsigned char ten_thousand;
	unsigned char thousand;
	unsigned char hundred;
	unsigned char tenth;

	hundred_thousand = data/100000;					
	data = data % 100000;
	ten_thousand = data/10000;
	data = data % 10000;
	thousand = data / 1000;
	data = data % 1000;
	hundred = data / 100;
	data = data % 100;
	tenth = data / 10;
	data = data % 10;

	if(hundred_thousand>0)
	{
		send_char(hundred_thousand + 0x30);	//0x30 added to become ASCII code
		send_char(ten_thousand + 0x30);
		send_char(thousand + 0x30);
		send_char(hundred + 0x30);
		send_char(tenth + 0x30);
		send_char(data + 0x30);
	}

	else if(ten_thousand>0) 
	{
		send_char(ten_thousand + 0x30);	//0x30 added to become ASCII code
		send_char(thousand + 0x30);
		send_char(hundred + 0x30);
		send_char(tenth + 0x30);
		send_char(data + 0x30);
	}
	else if(thousand>0)
	{
 		send_char(thousand + 0x30);	//0x30 added to become ASCII code
		send_char(hundred + 0x30);
		send_char(tenth + 0x30);
		send_char(data + 0x30);
	}
	else if(hundred>0)
	{
 		send_char(hundred + 0x30);	//0x30 added to become ASCII code
		send_char(tenth + 0x30);
		send_char(data + 0x30);
	}
	else if(tenth>0)
 	{
		send_char(tenth + 0x30);	//0x30 added to become ASCII code
		send_char(data + 0x30);
	}
	else send_char(data + 0x30);	//0x30 added to become ASCII code
}

void increment(unsigned long data)
{	
	unsigned short j;
	for(j=10;j>0;j--)
	{	lcd_goto(32);
		data=data+1;
		dis_num(data);
		delayy(10000);
	}

}


//==================subroutine ADC=========================

void read_adc(void)
{
	unsigned short i;
	unsigned long result_temp=0;
	for(i=2000;i>0;i-=1)			//looping 2000 times for getting average value 
	{
		ADGO = 1;					//ADGO is the bit 2 of the ADCON0 register
		while(ADGO==1);				//ADC start, ADGO=0 after finish ADC progress
		result=ADRESH;
		result=result<<8;			//shift to left for 8 bit
		result=result|ADRESL;		//10 bit result from ADC

		result_temp+=result;		
	}
	result = result_temp/2000;		//getting average value

}

unsigned short read_temp(void)
{
	unsigned short temp;
	temp=result;
	return temp;

}

//==================subroutine DELAY==========================
void delayy(unsigned short i)
{	
	for(;i>0;i--);
}
//=================subrouting Pause===========================
void pause (unsigned short e)


{
for(e=0;e<45*5; e++);   // for 45 seconds

}
//=================Subroutin feeder==========================

void feeder (void){
while(t<20){
t++;
run=1;
delayy(40000);
run=0;
delayy(60000);
direct=1;
delayy(40000);
direct=0;
delayy(60000);
break;

}
}
//=====================servo motor===========================
void servomotor (void){
while (t<20){
t++;

     servo = 1;
 for(e=1;e<=50; e++){
//__delay_us(1500);
  delayy(15000);
delayy(5000);
			}


	servo = 0;
for(e=1;e<=50; e++){
 delayy(20000);
	//delay(500);	
}


    servo = 1;
 for(e=1;e<=50; e++){
//__delay_us(20000);
   
			}

break;
}
}
     


